.include "tn13def.inc"
.include "START_ini.inc"

.equ	but	=1	;   
.equ	Div	=8	;  (   )-   

.equ	cod_run	=0	; " "
.equ	run_bef	=1	;    
.equ	Clock	=2	;  
.equ	REDY	=3	;   
.equ	Count_Clock =5	; 5, 6, 7 -  
.equ	setDiv1	=15	;      

.equ	com_1	=0b00010000	; 
.equ	com_2	=0b00010100	; 
.equ	com_3	=0b00010101	; 

.def	command =r22		;    
.def	T1	=r20		; 1
.def	pul_cyc	=r21		;   

;MACROS======================================================================================================
;   
/*.macro	LDR
		lds	r16,	@1	;@1 -    SRAM
		lsr r16 lsr r16 lsr r16 lsr r16 lsr r16 ;c  5  
		mov	@0,	r16	;@0 - ,   
.endm
;    SRAM
.macro	STR
		mov	r16,	@1	;@1 -  1    
		lsl r16 lsl r16 lsl r16 lsl r16 lsl r16 ;c  5  
		lds	r17,	@0	;@0 -    SRAM
		andi	r17,	~(7<<5)	; 3   ( )
		or	r16,	r17	;    
		sts	@0,	r16	;  SRAM
.endm
*/
;  ( switch)............................
.macro SPL_
		mov	r16,	@0	;@0 -   
		cpi	r16,	com_1	;,  
		brne	pc+3
		rcall	act1		;  1
		rjmp SPLend		;    
		cpi	r16,	com_2	;     
		brne	pc+3		;  
		rcall	act2		;  2
		rjmp SPLend		;  ,    
		cpi	r16,	com_3	;     2- 
		brne	pc+2
		rcall	act3

SPLend:
.endm
;  i/o........................................................................
.macro	Copy_io
		in	r16,	@1	;@1 -  i/o
		sts	@0,	r16	;@0 -   SRAM,  
.endm
;      .................................................
.macro	SavToBef
		lds	r16,	@1	;@1 -   SRAM  
		sts	@0,	r16	;@0 -   SRAM,  
.endm
;   ..................................................
.macro	FP
		lds	r16,	@0	;@0 -    
		andi	r16,	1<<@2	;@2 - (   )
		lds	r17,	@1	;@1 -    	
		andi	r17,	1<<@2	; r17   
		ldi	r18,	1<<@2	;@2 -  ( ,  )
		eor	r17,	r18	;   
		and	r16,	r17
		bst	r16,	@2	;  (  )
		;  .  =1 -     .
.endm
;   ..................................................
.macro	FN
		lds	r16,	@0	;@0 -    
		andi	r16,	1<<@2	;@2 - (   )
		lds	r17,	@1	;@1 -    	
		andi	r17,	1<<@2	; r17   
		ldi	r18,	1<<@2	;@2 -  ( ,  )
		eor	r16,	r18	;   
		and	r16,	r17
		bst	r16,	@2	;  (  )
		;  .  =1 -     .
.endm
;      (1)       ...........................
.macro A
		clt			; 
		lds 	r16,	@0	;@0 -  
		andi	r16,	1<<@1	;@1 -  (  )
		bst	r16,	@1	;   
.endm
;      (0)       ...........................
.macro AN
		clt			; 
		lds 	r16,	@0	;@0 -  
		ldi	r17,	1<<@1
		eor	r16,	r17
		andi	r16,	1<<@1	;@1 -  (  )
		bst	r16,	@1	;   
.endm



;SRAM========================================================================================================
					.DSEG
M:		.byte 1		;  
M_bef:		.byte 1		;  
image:		.byte 1		;  PINB
im_bef:		.byte 1		;    

;FLESH=======================================================================================================
					.CSEG
					.org 00
					rjmp RESET
					.org 03
					rjmp OVF

RESET:
		Ram_00
		SPini

;Timer.......................................................................
		ldi	r16,	03
		out	TCCR0B,	r16	; 64
		ldi	r16,	1<<TOIE0
		out	TIMSK0,	r16	;   
;Ports.........................................................................
		ldi	r16,	1
		out	DDRB,	r16	;PB0 - output another - input
		ldi	r16,	$FF
		out	PORTB,	r16	;PB0 -  ,  

	sei
main:		
Copy_io	image,	pinb			;  
		rcall	Fcoder		;  

		A	M,	redy
		brtc	m0
		SPL_	command		;  ( ++  switch - case a:)
M0:






SavToBef  im_bef, image			;   
rjmp main

















;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;  ..........................................................................
OVF:
push r16
in r16,sreg
push r16
		inc	T1		;   
		cpi	T1,div		;        
		brne	pc+7		;   lock
		clr	T1
		lds	r16,	M
		sbr	r16,	1<<Clock
		sts	M,	r16
pop r16
out sreg,r16
pop r16
reti
; ========================================================================================================
ACT1:
	cbi	portb,	0	;   
ret
; 2........................
ACT2:
	sbi	portb,	0	;   
ret
; 3.........................
ACT3:

ret
;.........................................................................
Fcoder:
cli

		FN image, im_bef, but	;     ( =0).
		brtc	pc+8
		lds	r16,	M	; 
		sbr	r16,	1<<cod_run ;   
		cbr	r16,	1<<redy	;c   
		sts	M,	r16	;c 
		clt			; 
		;..................................................
		AN	M,	cod_run	;      
		brts	FcodEnd

		FP M, M_bef, cod_run	;     
		brtc	pc+3
		clr 	pul_cyc		;c  
		clr	command		; 
		;.........................................................
		AN	image,	but	;,   
		bld	r2,	0	;c    2 -  0
		A	M,	Clock	;,   
		bld	r3, 	0	;   R3 bit0
		and	r2,	r3	;     
		bst	r2,	0	;  (    1 - =1)
		brtc	PC+2
		ori	command,1<<0	;    1   
		;.......................................................
		bst	r3,	0	;    
		brtc	PC+3
		lsl	command		;      
		inc	pul_cyc
		;.......................................................
		cpi	pul_cyc,4	;c   4  
		brne	FcodEnd
		clr	pul_cyc		;  
		lds	r16,	M
		cbr	r16,	1<<cod_run ;   
		sts	M,	r16	;  
		FN	M, M_bef, cod_run ;  
		lds	r16,	M
		bld	r16,	redy	;   -  
		sts	M,	r16

FcodEnd:
;     
lds	r16,	M
cbr	r16,	1<<Clock	;  
sts	M_bef,	r16
sts	M,	r16
sei
ret
































